<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   xmlns:componente="br.com.desenv.framework.componente.*"
			   close="titlewindowCloseHandler(event)"  
			   creationComplete="creationCompleteHandler(event)" 
			   title="Cadastro de Tipo Conta Gerencial"
			  maxWidth="1200" maxHeight="700"  
			   xmlns:visual="br.com.desenv.framework.component.visual.*"   xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
			   
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	
	<fx:Metadata>
		[Event(name="TipoContaContaGerIncluidoEvent")]
		[Event(name="TipoContaContaGerAtualizadoEvent")]
		[Event(name="TipoContaContaGerExcluidoEvent")]
		[Event(name="TipoContaContaGerSelecionadoEvent")]
		
	</fx:Metadata>

	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			import spark.events.TitleWindowBoundsEvent;
			
			import br.com.desenv.nepalign.vo.TipoContaContaGer;
			
			import br.com.desenv.nepalign.vo.ContaGerencial;
			import br.com.desenv.nepalign.vo.TipoConta;
			// Alguem passa a objeto para ca
			public var tipoContaContaGer : TipoContaContaGer = new TipoContaContaGer();
			
			[Bindable]
			private var listaContaGerencial: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaTipoConta: ArrayCollection = new ArrayCollection();

			
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function limparListaCampo(): void
			{
// Combo
				ignComboBoxAutoCompleteTipoConta.selectedIndex = -1;
// Combo
				ignComboBoxAutoCompleteContaGerencial.selectedIndex = -1;
			}
			
			// Chama ao completar o carregamento da pagina
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				var remoteObjectContaGerencial: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("contaGerencialService", listarContaGerencialResultHandler);	
				remoteObjectContaGerencial.getOperation("listar").send();
				var remoteObjectTipoConta: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("tipoContaService", listarTipoContaResultHandler);	
				remoteObjectTipoConta.getOperation("listar").send();
				
				// Se e um novo cadastro
				if (isNaN(this.tipoContaContaGer.id))
				{
					limparListaCampo();
				}
				// Se alguem passou o objeto
				else
				{
					//ignComboBoxAutoCompleteTipoConta.selectedItem = this.tipoContaContaGer.tipoConta;
					//ignComboBoxAutoCompleteContaGerencial.selectedItem = this.tipoContaContaGer.contaGerencial;
				}
			}
			
			private function listarContaGerencialResultHandler( event: ResultEvent ): void 
			{
				listaContaGerencial = event.result as ArrayCollection;
				listaContaGerencial.addItemAt(null, 0);
				
				if (this.tipoContaContaGer != null && this.tipoContaContaGer.contaGerencial != null)
				{
					for(var i:int = 1; i <= this.listaContaGerencial.length; i++)
					{
						var contaGerencialTemp: ContaGerencial = this.listaContaGerencial.getItemAt(i) as ContaGerencial;
						
						if (contaGerencialTemp.id == this.tipoContaContaGer.contaGerencial.id)
						{
							ignComboBoxAutoCompleteContaGerencial.selectedIndex = i;
							break;
						}
					}
				}	
			}
			private function listarTipoContaResultHandler( event: ResultEvent ): void 
			{
				listaTipoConta = event.result as ArrayCollection;
				listaTipoConta.addItemAt(null, 0);
				
				if (this.tipoContaContaGer != null && this.tipoContaContaGer.tipoConta != null)
				{
					for(var i:int = 1; i <= this.listaTipoConta.length; i++)
					{
						var tipoContaTemp: TipoConta = this.listaTipoConta.getItemAt(i) as TipoConta;
						
						if (tipoContaTemp.id == this.tipoContaContaGer.tipoConta.id)
						{
							ignComboBoxAutoCompleteTipoConta.selectedIndex = i;
							break;
						}
					}
				}	
			}
			
			
			
			// Chama quando fecha a janela no X
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- SALVAR E ATUALIZAR  --------------------------------	
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				if (validar(event))
				{
					// Se e alteracao
					if (isNaN(tipoContaContaGer.id) == false) 
					{
						tipoContaContaGer.tipoConta = ignComboBoxAutoCompleteTipoConta.selectedItem; 
						tipoContaContaGer.contaGerencial = ignComboBoxAutoCompleteContaGerencial.selectedItem; 
						var remoteObjectAtualizar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("tipoContaContaGerService", atualizarResultHandler);	
						remoteObjectAtualizar.getOperation("atualizar").send(tipoContaContaGer); 
					// Se e inclusao
					} 
					else 
					{
						tipoContaContaGer.tipoConta = ignComboBoxAutoCompleteTipoConta.selectedItem; 
						tipoContaContaGer.contaGerencial = ignComboBoxAutoCompleteContaGerencial.selectedItem; 
						var remoteObjectSalvar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("tipoContaContaGerService", salvarResultHandler);	
						remoteObjectSalvar.getOperation("salvar").send(tipoContaContaGer); 
					}
				}	
			}

			
			// Depois que salva fecha a janela
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.tipoContaContaGer = event.result as TipoContaContaGer;
				this.dispatchEvent(new ResultEvent("TipoContaContaGerIncluidoEvent",false, true, this.tipoContaContaGer, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			// Depois que atualiza fecha a janela
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.tipoContaContaGer = event.result as TipoContaContaGer;
				this.dispatchEvent(new Event("TipoContaContaGerAtualizadoEvent"));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- LIMPAR  --------------------------------	
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
			protected function buttonAdicionarContaGerencial_clickHandler(event:MouseEvent):void
			{
				var contaGerencialComponenteCadastro: ContaGerencialComponenteCadastro = new ContaGerencialComponenteCadastro();
				contaGerencialComponenteCadastro.addEventListener("ContaGerencialIncluidoEvent", atualizarListaContaGerencialPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(contaGerencialComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(contaGerencialComponenteCadastro);
			}
			
			private function atualizarListaContaGerencialPorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoContaGerencial: ContaGerencial = e.result as ContaGerencial;
				listaContaGerencial.addItem(novoContaGerencial);
				ignComboBoxAutoCompleteContaGerencial.selectedItem = novoContaGerencial;
			}
			protected function buttonAdicionarTipoConta_clickHandler(event:MouseEvent):void
			{
				var tipoContaComponenteCadastro: TipoContaComponenteCadastro = new TipoContaComponenteCadastro();
				tipoContaComponenteCadastro.addEventListener("TipoContaIncluidoEvent", atualizarListaTipoContaPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(tipoContaComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(tipoContaComponenteCadastro);
			}
			
			private function atualizarListaTipoContaPorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoTipoConta: TipoConta = e.result as TipoConta;
				listaTipoConta.addItem(novoTipoConta);
				ignComboBoxAutoCompleteTipoConta.selectedItem = novoTipoConta;
			}

			
// ---------------------------------- PESQUISAR AUTOR ABRINDO A LISTA  --------------------------------				
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<!-- <mx:Validator id="validatorObrigatorioSituacaoTipoContaContaGer" property="selectedItem" required="true" source="{comboBoxSituacaoTipoContaContaGer}" trigger="{comboBoxSituacaoTipoContaContaGer}" triggerEvent="valueCommit"/> -->
		

		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
					
	</fx:Declarations>
	

	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="720" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Tipo Conta:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoTipoConta" styleName="labelValidacao" text="{ignComboBoxAutoCompleteTipoConta.errorString}"/>
					<s:HGroup>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteTipoConta" dataProvider="{listaTipoConta}" labelField="descricao" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
						<s:Button id="buttonAdicionarTipoConta" width="30" label="+" click="buttonAdicionarTipoConta_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>		
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Conta Gerencial:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoContaGerencial" styleName="labelValidacao" text="{ignComboBoxAutoCompleteContaGerencial.errorString}"/>
					<s:HGroup>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteContaGerencial" dataProvider="{listaContaGerencial}" labelField="descricao" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
						<s:Button id="buttonAdicionarContaGerencial" width="30" label="+" click="buttonAdicionarContaGerencial_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>		



		</mx:GridRow>		
		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Button id="buttonSalvar" label="Salvar" click="buttonSalvar_clickHandler(event)"/>
				<s:Button id="buttonLimpar" label="Limpar" click="buttonLimpar_clickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>